from app.core.datasource.datasource import DataSourceBase
from app.core.datasource.hive import HiveDS
from configs.settings import DefaultOption, config
from utils import flat_map

HOST = config.get('HIVE', 'HOST')
PORT = config.get('HIVE', 'PORT')
USERNAME = config.get('HIVE', 'USERNAME')
PASSWORD =  config.get('HIVE', 'PASSWORD')
DATABASE_NAME = config.get('HIVE', 'DATABASE_NAME')
KERBEROS = config.get('HIVE', 'KERBEROS')
KEYTAB = config.get('HIVE', 'KEYTAB', vars=DefaultOption(config, 'HIVE', KEYTAB = None))
KRB5CONFIG = config.get('HIVE', 'KRB5CONFIG', vars=DefaultOption(config, 'HIVE', KRB5CONFIG = None))
KERBEROS_SERVICE_NAME = config.get('HIVE', 'KERBEROS_SERVICE_NAME', vars=DefaultOption(config, 'HIVE', KERBEROS_SERVICE_NAME = None))
PRINCIPAL = config.get('HIVE', 'PRINCIPAL', vars=DefaultOption(config, 'HIVE', PRINCIPAL = None))

hiveDs = HiveDS(**{'type': 'hive',
                    'host': HOST,
                    'port': PORT,
                    'username': USERNAME,
                    'password': PASSWORD,
                    'database_name': DATABASE_NAME,
                    'kerberos': KERBEROS,
                    'keytab': KEYTAB,
                    'krb5config': KRB5CONFIG,
                    'kerberos_service_name': KERBEROS_SERVICE_NAME,
                    'principal':PRINCIPAL})