from sqlalchemy import Boolean, Column, ForeignKey, Integer, String

from app.models.database import BaseModel


class JobJdbcDatasource(BaseModel):
    __tablename__ = "job_jdbc_datasource"

    id = Column(Integer, primary_key=True, index=True)
    # 数据源名称
    datasource_name = Column(String, nullable=False, unique=True, index=True)
    # 数据源
    datasource = Column(String, nullable=False)
    # 数据库名
    database_name = Column(String)
    # 数据库用户名
    jdbc_username = Column(String)
    # 数据库密码
    jdbc_password = Column(String)
    # jdbc url
    jdbc_url = Column(String)
    # jdbc driver
    jdbc_driver_class = Column(String)
    # 状态: 0 删除 1 启用 2 禁用
    status = Column(Integer, default=1, nullable=False)
    # 创建时间
    create_time = Column(Integer)
    # 创建人
    create_by = Column(String)
    # 更新时间
    update_time = Column(Integer)
    # 更新人
    update_by = Column(String)
    # 备注
    comments = Column(String)
    # 标签
    tag = Column(String)
    # kerberos 验证(0:未开启，1:开启)
    kerberos = Column(Integer)
    # keytab 文件
    keytab = Column(String)
    # krb5config 文件
    krb5config = Column(String)
    # service 名称
    kerberos_service_name = Column(String)
    # principal
    principal = Column(String)

